﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'Custom View class 
#Event: ItemClick (Position As Int, Value as String)
#DesignerProperty: Key: DecimalButton, DisplayName: Show Decimal, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: Hint, DisplayName: Hint, FieldType: String, DefaultValue: Enter a number
#DesignerProperty: Key: AnimationDuration, DisplayName: Animation Duration, FieldType: Int, DefaultValue: 300
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: #CE222222
private Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Panel
	Private slidingPanel As Panel
	Private const spHeight = 265dip, spWidth = 176dip As Int
	Private side As Int
	Private const SIDE_UP = 1, SIDE_DOWN = 2, SIDE_LEFT = 3, SIDE_RIGHT = 4 As Int
	Private top, left As Int
	Private mProps As Map
	Private flEditText1 As FloatLabeledEditText
	Private focused As Boolean
	Private LView1 As ListView
	Private ListItem As List
	Private LastSelectedIndex As Int
	Private GetSelectedIndex As Int
	Type Item (Text As String)
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	
	'flEditText1.Initialize("flEditText1")
	ListItem.Initialize
	
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	Dim parent As Panel = mBase.Parent
	slidingPanel.Initialize("")
	slidingPanel.Visible = False
	left = Min(mBase.Left + mBase.Width / 2 - 95dip, 100%x - spWidth)
	If 100%y - mBase.Top - mBase.Height - spHeight > 0 Then
		'below
		side = SIDE_DOWN
		top = mBase.Top + mBase.Height
	Else If mBase.Top > spHeight Then
		'above
		side = SIDE_UP
		top = mBase.Top - spHeight
	Else If mBase.Left + mBase.Width + spWidth < 100%x Then
		'right
		side = SIDE_RIGHT
		top = 100%y - spHeight
		left = mBase.Left + mBase.Width
	Else
		'left
		side = SIDE_LEFT
		top = 100%y - spHeight
		left = mBase.Left - spWidth
	End If
	parent.AddView(slidingPanel, left, top, spWidth, spHeight)
	mProps = Props
	CallSubDelayed(Me, "LoadPanelLayout")
End Sub

PUBLIC Sub LoadPanelLayout
	slidingPanel.LoadLayout("Combobox")
	slidingPanel.Elevation = 0dip
	Dim cd As ColorDrawable
	cd.Initialize(mProps.Get("BackgroundColor"), 3dip)
	slidingPanel.Background = cd
	LView1.Visible=True
	
	LView1.SingleLineLayout.Label.TextSize=15
	LView1.SingleLineLayout.Label.TextColor=Colors.Black
	LView1.Background=cd
	LView1.SingleLineLayout.ItemHeight=50dip
	
	Private R As Reflector
	R.Target=LView1
	R.RunMethod2("setVerticalScrollBarEnabled",False,"java.lang.boolean")
	R.RunMethod2("setVerticalFadingEdgeEnabled",False,"java.lang.boolean")
	R.RunMethod2("setOverScrollMode",2,"java.lang.int")
	
	
	
	flEditText1.RemoveView
	flEditText1.EditText.InputType = flEditText1.EditText.INPUT_TYPE_NONE
	flEditText1.Hint = mProps.Get("Hint")
	mBase.AddView(flEditText1, 0, 0, mBase.Width, mBase.Height)
	DesignerList
End Sub

Private Sub flEditText1_FocusChanged (HasFocus As Boolean)
	focused = HasFocus
	If HasFocus Then
		Show
	Else
		Hide
	End If
End Sub

Private Sub flEditText1_Click
	If focused Then Show
	
End Sub

private Sub DesignerList
	'Msgbox(ListItem.size,"")
	
	If ListItem.size>0 Then
		If LView1.Size>0 Then LView1.Clear
		For i=0 To ListItem.Size-1
			Dim Item As Item
			Item.Initialize
			Item = ListItem.Get(i)
			LView1.AddSingleLine(Item.Text)
		Next
		
	End If
	
	'If LView1.Size>0 Then flEditText1.Text=LView1.GetItem(1)
	
End Sub



Public Sub Show
	If slidingPanel.Visible Then Return
	If side = SIDE_UP Then
		slidingPanel.SetLayout(left, top + spHeight, spWidth, 0)
	else if side = SIDE_DOWN Then
		slidingPanel.SetLayout(left, top, spWidth, 0)
	Else If side = SIDE_LEFT Then
		slidingPanel.SetLayout(mBase.Left, top, 0, spHeight)
	Else If side = SIDE_RIGHT Then
		slidingPanel.SetLayout(mBase.Left + mBase.Width, top, 0, spHeight)
	End If
	slidingPanel.Visible = True
	slidingPanel.SetLayoutAnimated(mProps.Get("AnimationDuration"), left, top, spWidth, spHeight)

End Sub

Public Sub Hide
	slidingPanel.Visible = False
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub



Public Sub getText As String
	Return flEditText1.Text
End Sub
Public Sub setText(s As String)
	If flEditText1.IsInitialized = False Then
		CallSubDelayed2(Me, "setText", s)
		Return
	End If
	flEditText1.Text = s
End Sub


Public Sub SetItems(L As List)

	For i=0 To L.Size-1
		Dim Item As Item
		Item.Text=L.Get(i)
		ListItem.Add(Item)
	Next

End Sub

Public Sub setSelectedIndex(i As Int)
	LastSelectedIndex = i
	LView1.SetSelection(I)
End Sub

public Sub Size As Int
	Return ListItem.Size
End Sub


Public Sub GetItem(Index As Int) As String

	Return LView1.GetItem(Index)
	
End Sub

Sub LView1_ItemClick (Position As Int, Value As Object)

	Dim strRet As String = Value
	flEditText1.Text = strRet
	Hide
		
	CallSub3(CallBack, EventName & "_Selected", strRet,False)
End Sub


